;**********************************************************************
;                                                                     *
;    Filename:	    CH-3200-VOLT-02.asm                               *
;    Date:                                                            *
;    File Version:                                                    *
;                                                                     *
;    Author:                                                *
;    Company:                                                 *
;                                                                     *
;                                                                     *
;**********************************************************************
;                                                                     *
;  Files required:      0,0-99,9 *
;                                                          *
;                                                                     *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Notes:                                                           *
;                                                                     *
;                                                                     *
;                                                                     *
;                                                                     *
;**********************************************************************
;    16f819
;	list      p=16f819           ; list directive to define processor
;	#include <p16F819.inc>        ; processor specific variable definitions
;	errorlevel  2              ; suppress message 302 from list file
;	__CONFIG   _CP_ALL & _WRT_ENABLE_1536 & _CPD_ON & _CCP1_KRB3 & _DEBUG_OFF & _LVP_OFF & _BODEN_ON & _MCLR_ON & _WDT_ON & _PWRTE_ON & _INTRC_IO 

;    16f819
	list      p=16f88           	; list directive to define processor
	#include <p16F88.inc>        	; processor specific variable definitions
	errorlevel  2              	
	__CONFIG    _CONFIG1, _CP_ALL & _CCP1_RB3 & _DEBUG_OFF & _WRT_PROTECT_ALL & _CPD_ON & _LVP_OFF & _BODEN_ON & _MCLR_ON & _PWRTE_ON & _WDT_ON & _INTRC_IO
	__CONFIG    _CONFIG2, _IESO_OFF & _FCMEN_OFF

;=======================================================================================================
	cblock	0x020
;================================	
r_PORTB							;   
d_PORTB							;	
d_PORTA							;

ind_1									;     
ind_2									;     
ind_3									;     	
buf_ind_1								;   1 
buf_ind_2								;   2 
buf_ind_3								;   3  

perem1									; 
perem2									; 
perem5									; 

reg_ind									;    
b_zad_ind								;   
;================================
cher300_10								; 
cher02									; 
cher05									; 
;chet_10								;     1 
;cher60m								;     1 
;================================
flag_i1									;  
flag_i2									;  

flag_2									;     
flag_3									;  
flag_4									;  
flag_5
;================================
avtovyh									;     
;================================
adr_e									;     EEPROM
data_e									; 
chtteep								    ;     EEPROM
;================================
uskor                   		  		;      
uskor_1                 		    	;
;========================================
;================================
;    EEPROM
;========================================
flag_0									;*    
Up_alr_hi,Up_alr_lo						;*   
Dn_alr_hi,Dn_alr_lo						;*   
Vr_zak_lo								;*           
Vr_pov_lo								;*   
kalibr_hi,kalibr_lo						;*  
end_stek								;*
;========================================
Vr_cak_lo								;           
Vr_cpo_lo								;   
;========================================
;    
;========================================
; 
flag_s									; 
count									; 
temp									; 
R3										; 
R2										; 
R1										; 
R0										; 
; 
binu									; 
binh									; 
binl									; 
; 
edin									; 
dest									; 
sotn									; 
tysc									; 
dtys									;  
stys									;  
mlon									; 
;========================================
;========================================
;    16  
peAsu
peAsh									; _ 
peAsl									; 
peBsu
peBsh									; _ 
peBsl									; 
regsr									; 
flag_srv								; 
;========================================
peCsu									; _C
peCsh									; 
peCsl									; 
peDsu									; _D
peDsh									; 
peDsl									; 
sign
;========================================
schet_sim1								;   
schet_sim2								;   
;========================================
TEMP0 						  	 		; 
t_binu					  		 		; 
t_binh					  		 		; 
t_binl					  	 			; 
U_izm_hi					  	 		;  
U_izm_lo					  			;
;========================================
Chokr								    ;  
ChTiz					   			    ;  
Tih1				   				    ;    h1
Til1			   					    ; 
Tih2				   				    ; 
Til2				   				    ; 
Tih3				   				    ; 
Til3				   				    ; 
Tih4				   				    ; 
Til4				   				    ; 

SIN_hi			   					    ; 
SIN_lo				   				  	;

;========================================
	endc
;========================================
	cblock	0x07d	
;================================
w_temp                     				; variable used for context saving 
status_temp            		    		; variable used for context saving
pclath_temp        	  					; variable used for context saving
;========================================
	endc
;========================================

;===========================================================================================
;===========================================================================================
;   
#define		S_A		d_PORTB,1			;  
#define		S_B		d_PORTB,2			;  B
#define		S_C		d_PORTB,3			;  C	
#define		S_D		d_PORTB,4			;  D
#define		S_E		d_PORTB,5			;  E 
#define		S_F		d_PORTB,6			;  F
#define		S_G		d_PORTB,7			;  G
#define		S_H		d_PORTA,6			;  H

#define		SOT		d_PORTA,1			;    
#define		DES		d_PORTA,2			;    
#define		EDI		d_PORTA,7			;    

;      
;  
#define		CL_PA	b'00000000'			;    "0"      , "1"           
#define		SE_PA	b'10000110'			;      "1"         
;  
#define		CL_PB	b'00000001'			;    "0"      , "1"           
#define		SE_PB	b'00000000'			;      "1"         

;===========================================================================================
;   
#define		KRB1		PORTB,2				;  

#define		KRB3		PORTB,4				;  

#define		KRB2		PORTB,3				;  


#define		KRB4		PORTB,7				;  
#define		PORTKN	b'10011100'			;    

;===========================================================================================
;===========================================================================================
#define		INDK	flag_0,0			;  " "
#define		KVUP	flag_0,1			;  "    "
#define		KVZD	flag_0,2			;  "    "
#define		R_ind	flag_0,3			;  
;=================================


;=================================
;    
#define		REGRA	flag_2,0			;     
#define		UP_VOL	flag_2,1			;      
#define		DN_VOL	flag_2,2			;      
#define		ZD_AKO	flag_2,3			;      ( )
#define		ZD_AVR	flag_2,4			;    
#define		KALIBR	flag_2,5			;   
#define		RE_IND	flag_2,6			;  
#define		PROIZ	flag_2,7			;   
;=================================
#define		kl_no	flag_3,0			;   
#define		RELE1	flag_3,1			;   
#define		E_data	flag_3,2			;   
#define		MINUS	flag_3,3			;    
#define		B_MIG	flag_3,4			;   (1 , 0 )
#define		UST		flag_3,5			;    
#define		vp_rp	flag_3,6			;   0- , 1- 
;=================================
#define		LE_RI	flag_4,0			;   
#define		B24		flag_4,1			;
#define		BTE		flag_4,2			;      00
#define		BTE0_00	flag_4,3			;
#define		BRACON	flag_4,4			;   
#define		zad_op	flag_4,5			;   
;=================================
#define		f_KRB1	flag_5,0			;
#define		f_KRB2	flag_5,1			;
#define		f_KRB3	flag_5,2			;
#define		f_KRB4	flag_5,3			;
;=================================
;   
#define		TOCHKA1	flag_i2,0			;    
#define		TOCHKA2	flag_i1,1			; 
#define		TOCHKA3	flag_i1,2			; 
#define		TOCHm1	flag_i1,3			;    
#define		TOCHm2	flag_i1,4			; 1 -    2 .
#define		TOCHm3	flag_i1,5			; 0 -  
#define		RAZR1	flag_i1,6			;    
#define		RAZR2	flag_i1,7			; 0 -  
#define		RAZR3	flag_i1,0			; 1 -    2 .
;=================================
;   
#define		RAV		flag_srv,0			;   =
#define		BOL		flag_srv,1			;   >
#define		MEN		flag_srv,2			;   <
#define		BOL_RAV	flag_srv,3			;   >=
#define		MEN_RAV	flag_srv,4			;   <=
;=================================
#define		IZM_ACP		ADCON0,2		;    
;=================================




;=================================
#define		SPUAN	.15					;     
#define		DIND	.15					;      (  - .10 )
;======================================================================================
;  
#define		c0		b'01111110'			; 0-0
#define		c1		b'00001100'			; 1-1
#define		c2		b'10110110'			; 2-2 "z"
#define		c3		b'10011110'			; 3-3
#define		c4		b'11001100'			; 4-4 ""
#define		c5		b'11011010'			; 5-5 "S"
#define		c6		b'11111010'			; 6-6
#define		c7		b'00001110'			; 7-7
#define		c8		b'11111110'			; 8-8
#define		c9		b'11011110'			; 9-9
;======================================================================================
#define		c_		b'00000000'			;  "" 
#define		cM		b'10000000'			;  "-"
#define		cw		b'00000010'			;  ""
#define		cn		b'10101000'			; "n"
#define		cN		b'01101110'			; ""
#define		co		b'10111000'			; "o" 
#define		cE		b'11110010'			; "E"
#define		cr		b'10100000'			; "r"
#define		cd		b'10111100'			; "d"
#define		cb		b'11111000'			; "b"
#define		ct		b'11110000'			; "t"
#define		cA		b'11101110'			; "A"
#define		cC		b'01110010'			; "C"
#define		cH		b'11101100'			; "H"
#define		cP		b'11100110'			; "P"
#define		cc		b'10110000'			; "c"
#define		ch		b'11101000'			; "h"
#define		cL		b'01110000'			; "L"
#define		ci		b'00100000'			; "i"
#define		cg		b'11001110'			; "g"
#define		cF		b'11100010'			; "F"
#define		cU		b'01111100'			; "U"
#define		cu		b'00111000'			; "u"
#define		cY		b'11011100'			; ""

;======================================================================================

;=======================================================================================================
;**********************************************************************
		ORG		0x000      	   			; processor reset vector
 			nop
		goto	main           			; go to beginning of program
;=======================================================================================================
	ORG     0x004             			; interrupt vector location
			movwf   w_temp            	; save off current W register contents
			movf	STATUS,w          	; move STATUS register into W register
			movwf	status_temp       	; save off contents of STATUS register
			movf	PCLATH,W	  		; move PCLATH register into W register
			movwf	pclath_temp       	; save off contents of PCLATH register

			clrf	STATUS				;   0
;===============================================
			bcf		T1CON,TMR1ON		;  ,
			bcf		PIR1,TMR1IF			;      TMR1
			movlw	0xfc				; 
			movwf	TMR1H				; 
			movlw	0xfd				; 
			movwf	TMR1L				;  
;==============  	300 	
;========================================================================== 
;==============	    
			movf	b_zad_ind,f			;    
			BZ		$+2					;
			decf	b_zad_ind,f			; 
;==============	   
			call	indic				;
;========================================================================== 
			decfsz	cher300_10,f		;     10  
			goto	end_pr				; 
			movlw	.30					;     
			movwf	cher300_10			;
;========================================================================== 
;========  	10 		



;========================================================================== 
			decfsz	cher05,f			;     2  
			goto	end_pr				; 
			movlw	.5					;     
			movwf	cher05				;
;========================================================================== 
;==============  	2 
			btfss	B_MIG				;    
			goto	$+3					;
			bcf		B_MIG				;
			goto	$+2					;
			bsf		B_MIG				;
;========================================
			call	Voltmetr					;
;========================================
;========================================================================== 			
			decfsz	cher02,f			;     1  
			goto	end_pr				; 
			movlw	.2					;     
			movwf	cher02				;  1 
;==========================================================================
;==============  	1  start		;				
			;==============		   	
			movf	Vr_cak_lo,f			; 
			btfss	STATUS,Z			; 
		goto	decfvrem				; 
			bsf		BRACON				; 			
		goto	end_decfvrem			;	
decfvrem								;
			movlw	.1					;
			subwf	Vr_cak_lo,f			;
end_decfvrem							;
			;==============			
			;==============		    	
			movf	Vr_cpo_lo,f			; 
			btfss	STATUS,Z			; 
		goto	decf_open				; 
			bsf		zad_op				; 			
		goto	end_decf_open			; 	
decf_open								; 
			movlw	.1					;
			subwf	Vr_cpo_lo,f			;
end_decf_open
			;==============				;
			movf	avtovyh,f			;   
			SKPNZ						;
		goto	chet_1mi_m				;
			decfsz	avtovyh,f			;
		goto 	chet_1mi_m				;
			call	resautoexit			;
			;==============				;
;===============================================				
chet_1mi_m								;	
;===============================================
;==========================================================================
;==============  	1  end
;=================================
;=================================
;=================================
;=================================
end_pr
			bsf		T1CON,TMR1ON		;  ,

			movf    pclath_temp,w     	; retrieve copy of PCLATH register
			movwf	PCLATH            	; restore pre-isr PCLATH register contents
			movf    status_temp,w     	; retrieve copy of STATUS register
			movwf	STATUS            	; restore pre-isr STATUS register contents
			swapf   w_temp,f
			swapf   w_temp,w          	; restore pre-isr W register contents
		retfie                   	 	; return from interrupt
;=======================================================================================================
;*************************************************************************************************************************************************
deshif		addwf	PCL,f				;  
			retlw	b'01111110'			; "0"
			retlw	b'00001100'			; "1"
			retlw	b'10110110'			; "2"
			retlw	b'10011110'			; "3"
			retlw	b'11001100'			; "4"
			retlw	b'11011010'			; "5"
			retlw	b'11111010'			; "6"
			retlw	b'00001110'			; "7"
			retlw	b'11111110'			; "8"
			retlw	b'11011110'			; "9"
			retlw	b'00000000'			; "10"-""
			retlw	b'10000000'			; "11"-""				
;*************************************************************************************************************************************************
;*************************************************************************************************************************************************
con_dro		addwf	PCL,f				;  		 	 
			retlw	.0					; 0-		00			0   0,1 
			retlw	.1					; 1-		06			1  
			retlw	.1					; 2-		12			1   0,01 
			retlw	.2					; 3-		18			2   
			retlw	.3					; 4-		25			3
			retlw	.3					; 5-		31			3
			retlw	.4					; 6-		37			4
			retlw	.4					; 7-		43			4
			retlw	.5					; 8-		50			5
			retlw	.6					; 9-		56			6
			retlw	.6					; 10-		62			6
			retlw	.7					; 11-		68			7
			retlw	.8					; 12-		75			8
			retlw	.8					; 13-		81			8
			retlw	.9					; 14-		87			9
			retlw	.9					; 15-		93			9
			retlw	.0					; 16-		00			0  
;============================================================================================
;*******************************************************************************************************************************************
text_1		addwf	PCL,f				;   (   0)
			retlw	.12					;   ()  
			retlw	cc					; c
			retlw	ch					; h
			retlw	cM					; "-"
			retlw	c3					; 3
			retlw	c2					; 2
			retlw	c0					; 0
			retlw	c0					; 0
			retlw   cM					; "-"				
			retlw	c0					; 0
			retlw	c2					; 2
			retlw	cC					; 
					;	.12  
			retlw	.12					;   - retlw  
			retlw	b'11110010'			; "E"
			retlw	b'10100000'			; "r"
			retlw	b'10100000'			; "r"
			retlw	b'10111000'			; "o"
			retlw	b'10100000'			; "r"
			retlw	b'00000000'			; " "
			retlw   b'10111100'			; "d"
			retlw   b'11101110'			; "a"				
			retlw	b'11110000'			; "t"
			retlw	b'10110000'			; "c"
			retlw	b'11101001'			; "h."
					;	.24  
			retlw	.16					;   - retlw  
			retlw	b'11111110'			; "8"
			retlw	b'10000000'			; "-"
			retlw	b'01111110'			; "0"
			retlw	b'11011010'			; "5"
			retlw	b'11111010'			; "6"
			retlw	b'10000000'			; "-"
			retlw	b'10011110'			; 3-3
			retlw	b'00001110'			; 7-7				
			retlw	b'11001100'			; "4"
			retlw	b'10000000'			; "-"
			retlw	b'01111110'			; "0"
			retlw	b'11001100'			; "4"					
			retlw	b'10000000'			; "-"
			retlw	b'01111110'			; "0"					
			retlw	b'11011010'			; "5"				
					;	.40  
			retlw	.10					;   - retlw  
			retlw	b'00000000'			; " "
			retlw	b'11110010'			; "E"
			retlw	b'10100000'			; "r"
			retlw	b'10100001'			; "r."
			retlw	b'00000000'			; " "
			retlw	b'10111100'			; "d"
			retlw	b'11101110'			; "A"
			retlw   b'11110000'			; "t"				
			retlw	b'11101110'			; "a"
					;	.50   - 
			retlw	.3					;   - retlw  
			retlw	c0					; "0"
			retlw	cL					; "L"
			retlw	cw					; "--"
					;	.54    - 
			retlw	.4					;   - retlw  
			retlw	b'01110010'			; ""
			retlw	b'10111000'			; "o"
			retlw	b'01110000'			; "L"
					;	.58
			retlw	.12					;   - retlw  
			retlw	b'11100010'			; "F"
			retlw	b'11101110'			; "A"
			retlw	b'00001000'			; "i"
			retlw	b'00001100'			; "l"
			retlw	b'00111000'			; "u"
			retlw	b'10100000'			; "r"
			retlw	b'11110010'			; "E"
			retlw	c_					; " "
			retlw	c_					; " "
			retlw	c_					; " "
					;	.69  
			retlw	.4					;   +1
			retlw	cr					; "r"
			retlw	ci					; "i"
			retlw	cn					; "n"
					;	.73  prop
			retlw	.4					;   +1
			retlw	cA					; "A"
			retlw	co					; "o"
			retlw	cu					; "u"
					;	.77  iteg
			retlw	.4					;   +1
			retlw	cU					; "U"
			retlw	b'00000010'			; "-"
			retlw	b'00000010'			; "-"
					;	.81 Uu1 ---
			retlw	.4					;   +1
			retlw	cU					; "U"
			retlw	b'00010000'			; "_"
			retlw	b'00010000'			; "_"
					;	.85 Tel
			retlw	.4					;   +1
			retlw	b'11110000'			; "t"
			retlw	b'11110010'			; "E"
			retlw	b'01110000'			; "L"
					;	.89 /
			retlw	.4					;   +1
			retlw	b'10100000'			; "r"
			retlw	b'11110010'			; "E"
			retlw	b'11001110'			; "q"
					;	.93  Uu2 ---
			retlw	.4					;   - retlw  
			retlw	cA					; "A"
			retlw	b'00001000'			; "i"
			retlw	cn					; "n"
					;	.97  CAL ---
			retlw	.4					;   - retlw  
			retlw	cC					; "C"
			retlw	cA					; "A"
			retlw	cL					; "L"
;============================================================================================


;============================================================================================
;   
main		movlw	0x5					;  0
			movwf	FSR					; 
ClfMem		clrf	INDF				; 
			incf	FSR,f				; 
			movlw	0x80				;
			subwf	FSR,w				;
			BNZ 	ClfMem				;
			clrf	INDF				; 			
;============================================================================================
;============================================================================================
; 
			clrwdt						;   ++++++
;====================================
; 
			BANKSEL OSCTUNE			
			clrf	OSCTUNE				;     
			movlw	b'01110000'			;  8 
			movwf	OSCCON				; 
;====================================
			BANKSEL OPTION_REG			;    OPTION_REG
			movlw	b'00001111'			;   ( . ,   WDT, . 1:128)
			movwf	OPTION_REG			; 
;====================================
			movlw	b'00000001'			;    A   R0  ,   
			movwf	TRISA				;
			clrf	TRISB				; 
;====================================
		; 	  819
;			BANKSEL ADCON1
;			movlw	b'11001110'			;  , Ft/2,  1/0 (  )
;			movwf	ADCON1				; 			
;			BANKSEL ADCON0				; 
;			movlw	b'10000001'			; FOSC/64,  0,  
;			movwf	ADCON0				; 

		; 	  88
			BANKSEL ANSEL			; 
			movlw	b'00000001'		;
			movwf	ANSEL			; 1 			
			BANKSEL ADCON0			; 
			movlw	b'10000001'		; FOSC/64,  0,  
			movwf	ADCON0			; 			
			BANKSEL ADCON1
			movlw	b'11000000'		;  , Ft/2,  1/0   .
			movwf	ADCON1			; 			
		;  	TMP1	;


;==================================== 			
		;  	TMP1		; 
			BANKSEL T1CON				;   0
			movlw	b'00110001'			;  ,  4  = 1:8 - 125 000 
			movwf	T1CON				;
;============================================================================================
			call	vost_data			;     
;============================================================================================
		;  
			movlw	SPUAN				;
			movwf	uskor_1				; 
			movwf	uskor				; 
			
			movlw	.2					;  10   1 
			movwf	cher300_10			; 
			movwf	cher02				; 
			movwf	cher05				; 
			
			bcf		LE_RI				;    

			call	res_init			;
;============================================================================================
		;  
			movlw	b'11000000'			;
			movwf	INTCON				;     
			BANKSEL	PIE1				; 
			bsf		PIE1,TMR1IE			;    TIMER1
			bcf		STATUS,RP0			;   0
			bcf		STATUS,RP1			; 
;============================================================================================
;============================================================================================
			bsf		STATUS,RP0			;   1
			movlw	PORTKN				;      
			movwf	TRISB				; 
			bcf		STATUS,RP0			;   0			
			call	zaderj				;   

			btfsc	KRB3					;     
			goto	$+.2				; 	
		goto	vos_data				; 
			
			bsf		STATUS,RP0			;   1
			clrf	TRISB				;        
			bcf		STATUS,RP0			;   0
;============================================================================================			
;============================================================================================
		;      
			;==============				;
			movlw	.0					; 
			call	big_str				;   CH-25xx
			call 	och_left			;  
;============================================================================================
;   
ind
			clrwdt						;   ++++++
			;==============				;
			call	kondosdata			; 
			;==============				;		


			;==============				; 
			movf	U_izm_hi,w			; 				
			movwf	binh				; 			
			movf	U_izm_lo,w			; 
			movwf	binl				;
			bsf		BTE					;
			call	conv_volt			;

			;==============				;			
			call	ind_zad				;
			;==============				;
			movlw	.20					;
			movwf	b_zad_ind			;
			;==============				;
			call	upravlenie			;	(  )		
			;==============				;
			call	klava				; 
;--------------------------------------------				
kontr		btfss	UST					;   
			goto	ind					;    / 
;--------------------------------------------
;   
nast	
			clrwdt						;   ++++++
			btfss	KALIBR				; 	
		goto	gotus					; 	
			btfss	vp_rp				; 	
		goto	gotus					; 	
			movf	U_izm_hi,w			; 				
			movwf	binh				; 			
			movf	U_izm_lo,w			; 
			movwf	binl				;
			bsf		BTE					;
			call	conv_volt			;

gotus												
			call	upravlenie			;

			movfw	uskor				;
			movwf	b_zad_ind			;
			call	ind_zad				; 			
			call	klava				; 
		goto	kontr					; 
;============================================================================================
;============================================================================================
upravlenie								;   
;============================================================================================
;============================================================================================
;=======================================  
			btfsc	UST
		return			
			btfsc	KVUP				;     
		goto	control					;   
			btfsc	KVZD				; 
		goto	control					; 
			bcf	RELE1					; 
		return							; 			
;============================================================================================
control		;     
			;          
			btfsc		INDK			; 
	return								; 
			btfsc		KVUP			; 
	goto	connap						; 
			btfss		KVZD			; 
	return								; 
connap
			movfw	U_izm_hi			;     	
			movwf	peAsh				;     
			movfw	U_izm_lo			; 
			movwf	peAsl				;
			
			movfw	Up_alr_hi			;
			movwf	peBsh				; 
			movfw	Up_alr_lo			; 
			movwf	peBsl				;
			call	sravnenie			;
			btfss	MEN					;
		goto	alr_d2					;

			movfw	Dn_alr_hi			;
			movwf	peBsh				; 
			movfw	Dn_alr_lo			; 
			movwf	peBsl				;
			call	sravnenie			;
			btfss	BOL					;
		goto	alr_d2					;
			movfw	Vr_pov_lo			;     
			movwf	Vr_cpo_lo			;
			bcf		zad_op				;
		btfss		BRACON				; 	
	return								;    
			btfsc	KVZD				;   
		goto	$+.3					; 
			bcf		RELE1				;   
	return								; 
			bsf		RELE1				;
	return								; 
alr_d2									; 
			btfss	zad_op				;    
	return								; 
			movfw	Vr_zak_lo			;
			movwf	Vr_cak_lo			; 
			bcf		BRACON				; 			
			btfsc	KVZD				; 
		goto	$+.3					;  
			bsf		RELE1				;   
		goto	$+.2					; 
			bcf		RELE1				; 
			movlw	.58 				; 
			call	big_str				; 
			movlw	.255				; 
			movwf	b_zad_ind			;
	return								; 			

				
;============================================================================================
;============================================================================================
klava		;    
			BANKSEL	TRISB				;  TRISB
			movlw	PORTKN				;      
			movwf	TRISB				; 
			BANKSEL	PORTB				; 
;==================================== !!!!!!!!
			call	zaderj				;   
										;       
;====================================
			btfsc	KRB1					;   
		goto	t_PB3					; 
			btfsc	kl_no				; 
		goto	vyh						; 
			call	zaderj				;   
			btfsc	KRB1					;    			
		goto	end_kl_call				; 
			bcf		f_KRB1				;
;====================
			btfsc		vp_rp			;       1-   
		goto	$+3						; 
			bsf			vp_rp			;       < >
		goto	$+2						; 
			bcf			vp_rp			;       < >
vyb_re	
			call	vyb_fun				; 
		goto	end_kl_call				; 
;====================================		
t_PB3		btfsc	KRB3					;   
		goto	t_PB2					; 
			btfsc	kl_no				; 
		goto	vyh						; 
			call	zaderj				;   
			btfsc	KRB3					; 			
		goto	end_kl_call				; 			
			bcf		f_KRB3				;
;====================
			btfsc	vp_rp				;       1-   
		goto	$+3						; 
			bsf		LE_RI				;    .     
	goto	vyb_re						; 
			call	ustanov				; 
		goto	end_kl_call				; 
;====================================	
t_PB2		btfsc	KRB2					;   
		goto	t_PB4					;  
			btfsc	kl_no				; 
		goto	vyh						; 
			call	zaderj				;   
			btfsc	KRB2					; 			
		goto	end_kl_call				; 			
			bcf		f_KRB2				;
;====================			
			btfsc	vp_rp				;       1-   
		goto	$+3						; 
			bcf		LE_RI				;    
		goto	vyb_re					; 
			call	ustanov				; 
		goto	end_kl_call				; 
;====================================
;====================================
t_PB4		btfsc	KRB4					;   
		goto	end_klava				;  
			btfsc	kl_no				; 
		goto	vyh						; 
			call	zaderj				;   
			btfsc	KRB4					; 			
		goto	end_kl_call				; 			
			bcf		f_KRB4				;
;====================			
;     KRB4
		goto	end_kl_call				; 

;====================================
end_klava								;
			bcf		kl_no				;    			
			movlw	SPUAN				;   
			movwf	uskor_1				; 
			movwf	uskor				;

end_kl_call								;
			banksel	TRISB				;  TRISB
			clrf	TRISB				;        
			banksel	PORTB				; 

			bsf		f_KRB1				;
			bsf		f_KRB2				;
			bsf		f_KRB3				;
			bsf		f_KRB4				;
	return								;										
;====================================
vyh		;	 
			btfss	UST					;
		goto	end_vyh3				; 
			btfsc	vp_rp				;       
		goto	end_vyh1				; 
			btfsc	KRB4					;   PB3+PB1		
		goto	end_vyh1				; 
			btfsc	KRB1					; 
		goto	end_vyh1				; 			
			;==============				;     
			clrf	avtovyh				; 
			call	resautoexit
			;==============				;
		goto	end_vyh3				; 
;====================================
end_vyh1
			movlw	.5					; 
			subwf	uskor_1,w			;     1
			BZ		end_vyh2			;	
			decfsz	uskor,f				; 
		goto	end_vyh3				; 
			decf	uskor_1,f			; 
			movfw	uskor_1				; 
			movwf	uskor				; 
end_vyh2								;			
			bcf		kl_no				;				
end_vyh3								;	
			bsf		f_KRB1				;
			bsf		f_KRB2				;
			bsf		f_KRB3				;
			bsf		f_KRB4				;
						
			banksel TRISB				;  TRISB
			clrf	TRISB				;        
			banksel PORTB				; 
	return								;
;============================================================================================
resautoexit
			call	zap_eeprom			;     
			bcf		UST					;    
			clrf	flag_2				;    			
			bcf		vp_rp				;   0- 		
			bcf		LE_RI				;   
res_init
			movfw	Vr_zak_lo			;
			movwf	Vr_cak_lo			; 
			bcf		BRACON				; 			
			movfw	Vr_pov_lo			;
			movwf	Vr_cpo_lo			;
			bcf		zad_op				;			
	return								; 
;============================================================================================
zaderj				;   
			movlw	.100					; .200
			movwf	TEMP0				; 
			decfsz	TEMP0,f				; 
			goto	$-1					; 		
		return							; 		
;============================================================================================
;============================================================================================						
;    
vyb_fun
;====================================
			banksel	TRISB			;  TRISB
			clrf	TRISB			;        
			banksel	PORTB			; 

			bsf		kl_no			;   
			bsf		UST				; 
			clrf	flag_i1			;    	
			clrf	flag_i2			; 
;====================================			
			movlw	DIND			;   
			movwf	avtovyh			; 
;====================================
			btfss	vp_rp			;     
		goto	pr_pr				;    			
;====================================
			btfsc	REGRA			;   
		goto	REGRA_f				; 
			btfsc	UP_VOL			;     
		goto	UP_VOL_f			; 			
			btfsc	DN_VOL			;     
		goto	DN_VOL_f			; 
			btfsc	ZD_AKO			;     ( )
		goto	ZD_AKO_f			; 
			btfsc	ZD_AVR			;   
		goto	ZD_AVR_f			; 			
			btfsc	KALIBR			;  
		goto	KALIBR_f			; 			
			btfsc	RE_IND			;  
		goto	RE_IND_f			; 			
			btfsc	PROIZ			;   
		goto	PROIZ_f				; 			
		goto	REGRA_f				; 						
;=================================
pr_pr								; 		
			btfsc	LE_RI			;
		goto	prev				; 	 
;=================================
			;   
			btfsc	REGRA			;   REGRA
		goto	UP_VOL_f			;   UP_VOL
			btfsc	UP_VOL			; 
		goto	DN_VOL_f			; 
			btfsc	DN_VOL			; 
		goto	ZD_AKO_f			; 
			btfsc	ZD_AKO			; 
		goto	ZD_AVR_f			; 
			btfsc	ZD_AVR			; 
		goto	KALIBR_f			; 
			btfsc	KALIBR			; 
		goto	RE_IND_f			; 			
			btfsc	RE_IND			;   RE_IND 
		goto	PROIZ_f				;   PROIZ
		goto	REGRA_f				;
;=================================
prev			;    - 
			btfsc	REGRA			;   REGRA
		goto	PROIZ_f				;    PROIZ
			btfsc	PROIZ			; 
		goto	RE_IND_f			; 
			btfsc	RE_IND			; 
		goto	KALIBR_f			; 
			btfsc	KALIBR			; 
		goto	ZD_AVR_f			; 
			btfsc	ZD_AVR			; 
		goto	ZD_AKO_f			; 
			btfsc	ZD_AKO			; 
		goto	DN_VOL_f			; 
			btfsc	DN_VOL			; 
		goto	UP_VOL_f			; 
		goto	REGRA_f				; 
;===============================================
		;     
REGRA_f		clrf	flag_2			; 
			bsf		REGRA			;
;====================================
			btfsc	vp_rp			;     
		goto	REGRA_d				;    
			movlw	.89				; 		
		goto	end_vybor_f			; 
REGRA_d		btfss	KVZD			;  "    "
		goto	i_KVUP				; 
			movlw	b'00000010'		;  _
			movwf	ind_1			;
			movlw	cU				;  U
			movwf	ind_2			;			
			movlw	b'00000010'		;  _
			movwf	ind_3			;
	return							; 
i_KVUP		btfss	KVUP			;  "    "
		goto	i_INDK
			movlw	b'00010000'		;  _
			movwf	ind_1			;
			movlw	cN				;  
			movwf	ind_2			;			
			movlw	b'00010000'		;  _
			movwf	ind_3			;
	return							; 
i_INDK								;  " "
			movlw	ci				;  i 
			movwf	ind_1			;
			movlw	cn				;  n
			movwf	ind_2			;			
			movlw	cd				;  d
			movwf	ind_3			;
			bsf		INDK			;   
	return							;  
;===============================================
	;       
UP_VOL_f	clrf	flag_2			; 
			bsf		UP_VOL			;
;====================================
			btfsc	vp_rp			;     
		goto	UP_VOL_d			;    
			movlw	.77				; t--
		goto	end_vybor_f			; 
UP_VOL_d		
			movfw	Up_alr_hi		; 
			movwf	binh			; 
			movfw	Up_alr_lo		; 
			movwf	binl			; 
		goto	end_vybor1			; 
;===============================================
	;      
DN_VOL_f	clrf	flag_2			; 
			bsf		DN_VOL			;
;====================================
			btfsc	vp_rp			;     
		goto	DN_VOL_d			;    
			movlw	.81				; t__ ---
		goto	end_vybor_f			; 
DN_VOL_d		
			movfw	Dn_alr_hi		; 
			movwf	binh			; 
			movfw	Dn_alr_lo		; 
			movwf	binl			; 
		goto	end_vybor1			; 
;===============================================
	;          
ZD_AKO_f	clrf	flag_2			; 
			bsf		ZD_AKO			;
;====================================
			btfsc	vp_rp			;     
		goto	ZD_AKO_d			;    
			movlw	.93				;  UAc ---
		goto	end_vybor_f			; 
ZD_AKO_d		
			clrf	binh			; 
			movfw	Vr_zak_lo		; 
			movwf	binl			; 
frfr		bcf		TOCHKA2			;
			bcf		TOCHKA3			;
			bcf		BTE				; 
			call    bin_dec			; 
			goto	end_vybor2		; 
;===============================================
	;  
ZD_AVR_f	clrf	flag_2			; 
			bsf		ZD_AVR			;
;====================================
			btfsc	vp_rp			;     
		goto	ZD_AVR_d			;    
			movlw	.73				; 
		goto	end_vybor_f			; 
ZD_AVR_d		
			clrf	binh			; 
			movfw	Vr_pov_lo		; 
			movwf	binl			; 
		goto	frfr				; 	
;===============================================
	; 
KALIBR_f	clrf	flag_2			; 
			bsf		KALIBR			;
;====================================
			btfsc	vp_rp			;     
		goto	KALIBR_d			;    
			movlw	.97				;  Uco ---
		goto	end_vybor_f			; 
KALIBR_d							; 
			movfw	U_izm_hi		; 				
			movwf	binh			; 			
			movfw	U_izm_lo		; 
			movwf	binl			; 
		goto	end_vybor1			; 		 			
;===============================================
		;  
RE_IND_f	clrf	flag_2			; 
			bsf		RE_IND			;
;====================================
			btfsc	vp_rp			;     
		goto	RE_IND_d			;    
			movlw	.69				; 		
		goto	end_vybor_f			; 
RE_IND_d	btfss	R_ind			;  " "
		goto	i_RE_IND			; 
			movlw	cC				;  - 
			movwf	ind_1			;
			movlw	cE				;  -
			movwf	ind_2			;			
			movlw	cL				;  -
			movwf	ind_3			;
	return							;  
i_RE_IND
			movlw	cd				;  -
			movwf	ind_1			;
			movlw	cr				;  -
			movwf	ind_2			;			
			movlw	co				;  -
			movwf	ind_3			;
	return							; 
;===============================================
	;   
PROIZ_f		clrf	flag_2			; 
			bsf		PROIZ			;
;====================================
			btfsc	vp_rp			;     
		goto	PROIZ_d				;    
			movlw	.85				; . 
		goto	end_vybor_f			; 
PROIZ_d		movlw	.24				; . 
			call	big_str			;   
			movlw	.85				; . 
			call	big_str			;   	
	return							;  
;===============================================
;===============================================
;     
;===============================================
end_vybor_f							; 
			btfsc	LE_RI			; 
		goto	$+3
			call	big_str			;   
	return							;  
			call	big_str_re		;   
	return							; 
end_vybor1							; 
			bsf		BTE				; 
			call    bin_dec			; 
			btfsc	R_ind
		goto	$+.4
			bsf		TOCHKA2			;
			bcf		TOCHKA3			;
		goto	$+.3	
			bcf		TOCHKA2			;
			bsf		TOCHKA3			;
end_vybor2							; 
			movfw	edin			; 
			movwf	ind_3			; 
			movfw	dest			; 
			movwf	ind_2			; 
			movfw	sotn			; 
			movwf	ind_1			;
	return							; 
;============================================================================================
;============================================================================================






;============================================================================================
;    
ustanov	
;====================================
			banksel	TRISB				;  TRISB
			clrf	TRISB				;        
			banksel	PORTB				; 
			
			bsf		kl_no			;   
			movlw	DIND			;   
			movwf	avtovyh			;   

			
			btfsc	REGRA			;    
			goto	u_REGRA			;
						
			btfsc	UP_VOL			;     
			goto	u_UP_VOL		; 

			btfsc	DN_VOL			;     
			goto	u_DN_VOL		; 
			
			btfsc	ZD_AKO			;     ( )
			goto	u_ZD_AKO		; 

			btfsc	ZD_AVR			;   
			goto	u_ZD_AVR		; 			
			
			btfsc	KALIBR			;  
			goto	u_KALIBR		; 

			btfsc	RE_IND			;  
			goto	u_RE_IND		; 
	return							; 
;====================================
;    
u_REGRA				
			btfsc	f_KRB3			; 
		goto	kk_REGRA			;
			btfss	INDK			;
		goto	$+.4				;
			bcf		INDK			;
			bsf		KVUP			;
	goto	REGRA_d					;
			btfss	KVUP			;
		goto	$+.4				;
			bcf		KVUP			;
			bsf		KVZD			;
	goto	REGRA_d					;				
			bcf		KVZD			;
			bsf		INDK			;
	goto	REGRA_d					;

kk_REGRA	btfsc	f_KRB2			; 
	goto	REGRA_d					;	
			btfss	INDK			;
		goto	$+.4				;
			bcf		INDK			;
			bsf		KVZD			;
	goto	REGRA_d					;
			btfss	KVZD			;
		goto	$+.4				;
			bcf		KVZD			;
			bsf		KVUP			;
	goto	REGRA_d					;
			bcf		KVUP			;
			bsf		INDK			;
	goto	REGRA_d					;
;====================================
;  
u_RE_IND			
			btfss	R_ind			;
		goto	$+.3				;
			bcf		R_ind			;
		goto	$+.2	
			bsf		R_ind			;
	goto	RE_IND_d				;
		
;====================================
;=========================================
u_KALIBR	;  
			btfsc	f_KRB2				; + 
		goto	kk_KALIBR				;
	
			movlw	0x7f				;
			movwf	peAsh				;
			movlw	0xff				;
			movwf	peAsl				;

			movf	kalibr_hi,w			;
			movwf	peBsh				;
			movf	kalibr_lo,w			;
			movwf	peBsl				;
			call	sravnenie			;
			btfss	BOL					;
		goto	kk_KALIBR				;
			movlw	.5					;
			addwf	kalibr_lo,f			;
			btfsc	STATUS,C			;
			incf	kalibr_hi,f			;
		goto	end_KALIBR				; 
kk_KALIBR								; 
			btfsc	f_KRB3				; - 
	goto	end_KALIBR					; 
			clrf	peAsh				; 1 cek		
			movlw	.1
			movwf	peAsl				;
	
			movf	kalibr_hi,w			;
			movwf	peBsh				;
			movf	kalibr_lo,w			;
			movwf	peBsl				;
			call	sravnenie			;
			btfss	MEN					;
	goto	end_KALIBR					; 
			movlw	.5					;
			subwf	kalibr_lo,f			;
			btfss	STATUS,C			;
			decf	kalibr_hi,f			;
end_KALIBR								;
	goto	KALIBR_d					;
;=========================================
;   
u_ZD_AVR
			btfsc	f_KRB3				; + 
		goto	kk_ZD_AVR				;
			clrf	peAsh				;
			movlw	.240				; 240sek
			movwf	peAsl				;

			clrf	peBsh			;
			movf	Vr_pov_lo,w		;
			movwf	peBsl			;
			call	sravnenie		;
			btfss	BOL				;
		goto	kk_ZD_AVR			;
			movlw	.1				;
			addwf	Vr_pov_lo,f		;
		goto	end_ZD_AVR			; 
kk_ZD_AVR							; 
			btfsc	f_KRB2			; - 
	goto	end_ZD_AVR				; 
			clrf	peAsh			;	
			clrf	peAsl			;

			clrf	peBsh			;
			movf	Vr_pov_lo,w		;
			movwf	peBsl			;
			call	sravnenie		;
			btfss	MEN				;
	goto	end_ZD_AVR				; 
			movlw	.1				;
			subwf	Vr_pov_lo,f		;
end_ZD_AVR							;
	goto	ZD_AVR_d					;
;=========================================
;=========================================
;     
u_UP_VOL
			btfsc	f_KRB3			; + 
		goto	kk_UP_VOL			;
			movlw	0x03			; +99,9
			movwf	peAsh			;
			movlw	0xe7			;
			movwf	peAsl			;
			
			movf	Up_alr_hi,w		;
			movwf	peBsh			;
			movf	Up_alr_lo,w		;
			movwf	peBsl			;
			call	sravnenie		;
			btfss	BOL				;
		goto	kk_UP_VOL			;
			movlw	.1				;
			addwf	Up_alr_lo,f		;
			btfsc	STATUS,C		;
			incf	Up_alr_hi,f		;
		goto	end_UP_VOL			; 

kk_UP_VOL							; 
			btfsc	f_KRB2			; - 
	goto	end_UP_VOL				; 
			movfw	Dn_alr_hi		;     Dn_alr+1,0
			movwf	peAsh			;		
			movfw	Dn_alr_lo		;
			movwf	peAsl			;
			movlw	.10				; + 1.0 v
			addwf	peAsl,f			;
			btfsc	STATUS,C		;
			incf	peAsh,f			;
			
			movf	Up_alr_hi,w		;
			movwf	peBsh			;
			movf	Up_alr_lo,w		;
			movwf	peBsl			;
			call	sravnenie		;
			btfss	MEN				;
	goto	end_UP_VOL				; 
			movlw	.1				;
			subwf	Up_alr_lo,f		;
			btfss	STATUS,C		;
			decf	Up_alr_hi,f		;
	goto	end_UP_VOL				; 
end_UP_VOL							;
	goto	UP_VOL_d				;
;=========================================
;=========================================
;     
u_DN_VOL
			btfsc	f_KRB3			; + 
		goto	kk_DN_VOL			;
			movfw	Up_alr_hi		;    
			movwf	peAsh			;     --1,0
			movfw	Up_alr_lo		;  
			movwf	peAsl			;
			movlw	.10				;   1.0 v
			subwf	peAsl,f			;
			btfss	STATUS,C		;
			decf	peAsh,f			;
			
			movf	Dn_alr_hi,w		;
			movwf	peBsh			;
			movf	Dn_alr_lo,w		;
			movwf	peBsl			;
			call	sravnenie		;
			btfss	BOL				;
		goto	kk_DN_VOL			;
			movlw	.1				;
			addwf	Dn_alr_lo,f		;
			btfsc	STATUS,C		;
			incf	Dn_alr_hi,f		;
		goto	end_DN_VOL			; 
kk_DN_VOL							; 
			btfsc	f_KRB2			; - 
	goto	end_DN_VOL				; 
			clrf	peAsh			;	00	
			clrf	peAsl			;
			movf	Dn_alr_hi,w		;
			movwf	peBsh			;
			movf	Dn_alr_lo,w		;
			movwf	peBsl			;
			call	sravnenie		;
			btfss	MEN				;
	goto	end_DN_VOL				; 
			movlw	.1				;
			subwf	Dn_alr_lo,f		;
			btfss	STATUS,C		;
			decf	Dn_alr_hi,f		;
end_DN_VOL							;
	goto	DN_VOL_d					;
;=========================================
;=========================================
u_ZD_AKO	;     ( )
			btfsc	f_KRB3			; + 
		goto	kk_ZD_AKO			;
			clrf	peAsh			;
			movlw	.240			; 240sek
			movwf	peAsl			;

			clrf	peBsh			;
			movf	Vr_zak_lo,w		;
			movwf	peBsl			;
			call	sravnenie		;
			btfss	BOL				;
		goto	kk_ZD_AKO			;
			movlw	.1				;
			addwf	Vr_zak_lo,f		;
		goto	end_ZD_AKO			; 
kk_ZD_AKO							; 
			btfsc	f_KRB2			; - 
	goto	end_ZD_AKO				; 
			clrf	peAsh			;	
			clrf	peAsl			;

			clrf	peBsh			;
			movf	Vr_zak_lo,w		;
			movwf	peBsl			;
			call	sravnenie		;
			btfss	MEN				;
	goto	end_ZD_AKO				; 
			movlw	.1				;
			subwf	Vr_zak_lo,f		;
end_ZD_AKO							;
	goto	ZD_AKO_d				;
;=========================================

;=========================================











;*************************************************************************************************
big_str								;   
			movwf	perem2			; 		
			clrf	flag_i1			;    	
			call 	och_left		;  
			movfw	perem2			;   
			movwf	schet_sim2		; 
			call 	text_1			;  
			movwf 	schet_sim1		;      
infch		incf	schet_sim2,f	;    
			decfsz	schet_sim1,f	;  .   1    0
			goto	pr				;  
	return
pr			clrwdt					;   ++++++
			movfw	ind_2			;  2   1 
			movwf	ind_1			;   
			movfw	ind_3			;  3   2 
			movwf	ind_2			;   
			movfw	schet_sim2		;    
			call 	text_1			;   
			movwf	ind_3			;   
			clrwdt					;   ++++++
			movf	b_zad_ind,f		;	
			BNZ		$-3				;
			movlw	.65				;
			movwf	b_zad_ind		;
			goto	infch			;  
;*************************************************************************************************
big_str_re							;       
			movwf	perem2			; 		
			clrf	flag_i1			;    	
			call 	och_ring		;  
			movfw	perem2			;   
			movwf	schet_sim2		; 
			call 	text_1			;  
			movwf 	schet_sim1		;      
			;movfw	perem2
			addwf	schet_sim2,f
infch_re	decf	schet_sim2,f	;    
			decfsz	schet_sim1,f	;  .   1    0
			goto	pr_re			; 	 
			;call 	och_ring		;  
	return
pr_re		clrwdt					;   ++++++
			movfw	ind_2			;  2   1 
			movwf	ind_3			;   
			movfw	ind_1			;  3   2 
			movwf	ind_2			;   
			movfw	schet_sim2		;    
			call 	text_1			;   
			movwf	ind_1			;   
			clrwdt					;   ++++++
			movf	b_zad_ind,f		;	
			BNZ		$-3				;
			movlw	.65				;
			movwf	b_zad_ind		;
			goto	infch_re		; 	 
;*************************************************************************************************
			;   "<-"
och_left	movlw	.4				;    +1
			movwf	schet_sim2		;   
dec_left	decfsz	schet_sim2,f	;  .   1    0
			goto	$+.2			; 	 
		return						; 	 
			clrwdt					;   ++++++
			movfw	ind_2			;  2   1 
			movwf	ind_1			;   
			movfw	ind_3			;  3   2 
			movwf	ind_2			;   
			clrf	ind_3			;  3 
			clrwdt					;   ++++++
			movf	b_zad_ind,f		;	
			BNZ		$-3				;
			movlw	.65				;
			movwf	b_zad_ind		;
			goto	dec_left		; 	 
;*************************************************************************************************
			;   "->"
och_ring	movlw	.4				;    +1
			movwf	schet_sim2		;   
dec_ring	decfsz	schet_sim2,f	;  .   1    0
			goto	$+.2			; 	 
		return						; 	 
			clrwdt					;   ++++++
			movfw	ind_2			;  2   1 
			movwf	ind_3			;   
			movfw	ind_1			;  3   2 
			movwf	ind_2			;   
			clrf	ind_1			;  3 
			clrwdt					;   ++++++
			movf	b_zad_ind,f		;	
			BNZ		$-3				;
			movlw	.65				;
			movwf	b_zad_ind		;
			goto	dec_ring		; 	 
;*************************************************************************************************
;===================================================================================
;   / 	
;============================================================================================
indic								;   
;=============================================	
			btfsc	TOCHKA1			;   
			bsf		ind_1,0			; 
			btfsc	TOCHKA2			; 
			bsf		ind_2,0			; 
			btfsc	TOCHKA3			; 
			bsf		ind_3,0			; 
;=============================================	
;=============================================	
i1ry		btfss	reg_ind,0		; 
		goto	i2ry				; 
			movfw	ind_1			;      ()
			movwf	r_PORTB			;   
			btfss	RAZR1			; 
			goto	ir1t			;   
;=========================			; 
			btfss	B_MIG			; 
			goto	ir1t			;   0  
			movlw	b'00000001'		; 
			andwf	r_PORTB,f		;   1  
			goto	ir1t			; 
;=========================			; 	
ir1t		btfss	TOCHm1			; 
			goto	ir1				;   
;=========================			; 
			btfss	B_MIG			;  
			bcf		r_PORTB,0		;   0  
;=========================			; 
ir1			call	indiprot		; 
			clrf	reg_ind			; 
			bsf		reg_ind,1		; 
	return							; 
;=============================================	
;=============================================		
i2ry		btfss	reg_ind,1		; 
		goto	i3ry				; 
			movfw	ind_2			;      ()
			movwf	r_PORTB			;   
			btfss	RAZR2			; 
			goto	ir2t			;   
;=============================================		
			btfss	B_MIG			; 
			goto	ir2t			;   0  
			movlw	b'00000001'		; 
			andwf	r_PORTB,f		;   1  
			goto	ir2t			; 
;=========================			; 		
ir2t		btfss	TOCHm2			; 
			goto	ir2				;   
;=========================			; 
			btfss	B_MIG			;  
			bcf		r_PORTB,0		;   0  
;=========================			; 
ir2			call	indiprot		; 
			clrf	reg_ind			; 
			bsf		reg_ind,2		; 
	return							; 
;=============================================	
;=============================================	
i3ry								; 
			movfw	ind_3			;      ()
			movwf	r_PORTB			;   
			btfss	RAZR3			; 
			goto	ir3t			;   
;=============================================		
			btfss	B_MIG			; 
			goto	ir3t			;   0  
			movlw	b'00000001'		; 
			andwf	r_PORTB,f		;   1  
			goto	ir3t			; 
;=========================			; 		
ir3t		btfss	TOCHm3			; 
			goto	ir3				;   
;=========================			; 
			btfss	B_MIG			;  
			bcf		r_PORTB,0		;   0  
;=========================			; 
ir3			call	indiprot		;
			clrf	reg_ind			;
			bsf		reg_ind,0		;
	return							; 
;=============================================	
;=============================================	
indiprot	;     				
			;   c     ()			
			movfw	PORTB			;  
			movwf	d_PORTB			; 
			movfw	PORTA			; 
			movwf	d_PORTA			; 
;====================================
			movlw	CL_PA			;   A (c  RA4/3   )  
			andwf	d_PORTA,f		;			
			movlw	SE_PA			;      off
			iorwf	d_PORTA,f		; 

			movlw	CL_PB			;   A (c  RA4   )  
			andwf	d_PORTB,f		;			
			movlw	SE_PB			;      off
			iorwf	d_PORTB,f		; 
;====================================			
			movfw	d_PORTA			;  
			movwf	PORTA			; 
			movfw	d_PORTB			; 
			movwf	PORTB			;   
;====================================
			
			btfsc	r_PORTB,0		;  
			bsf		S_H				;   
			btfsc	r_PORTB,1		;
			bsf		S_A				;			
			btfsc	r_PORTB,2		;
			bsf		S_B				;
			btfsc	r_PORTB,3		;
			bsf		S_C				;
			btfsc	r_PORTB,4		;
			bsf		S_D				;
			btfsc	r_PORTB,5		;
			bsf		S_E				;
			btfsc	r_PORTB,6		;
			bsf		S_F				;
			btfsc	r_PORTB,7		;
			bsf		S_G				;			

			btfsc	reg_ind,0		;   
			bcf		SOT				; 
			btfsc	reg_ind,1		; 
			bcf		DES				; 
			btfsc	reg_ind,2		; 
			bcf		EDI				; 
;=====================================
			btfsc	RELE1			;   
		goto	$+3					; 
			bcf		d_PORTB,0		; 
		goto	$+2					; 
			bsf		d_PORTB,0		; 			
;=====================================			
;			btfsc	RELE2			;   
;		goto	$+3					; 
;			bcf		d_PORTA,0		; 
;		goto	$+2					; 
;			bsf		d_PORTA,0		; 			
;=====================================
			movfw	d_PORTA			;  
			movwf	PORTA			; 
			movfw	d_PORTB			; 
			movwf	PORTB			; 
	return							; 
;============================================================================================	
;********************   *************************************************************
ind_zad								;   
			clrwdt					;   ++++++
			movf	b_zad_ind,f		;	
			BNZ		$-3				;
			movlw	.60				;
			movwf	b_zad_ind		;
		return						; 					; 
;*************************************************************************************************
;============================================================================================
;******************** *********************************************************
vost_data								; 
			movlw	(end_stek-flag_0)+1	; 
			movwf	chtteep				; 
			movlw	flag_0
			movwf	FSR				;     
			clrf	adr_e				; 			
povch			
			call	prov_eep			;    EEPROM
			movwf	INDF				;      
			incf	FSR,f			
			incf	adr_e,f				;   EEPROM
			decfsz	chtteep,f				;      
			goto	povch				;    
	return								; 
;********************
;=================================================================================================
prov_eep	call	rd_eeprom			;  
			movf	data_e,w
			movwf	perem1				; 
			incf	adr_e,f				;   EEPROM
			call	rd_eeprom			;   ()
			movf	data_e,w			;
			subwf	perem1,w			;      EEPROM
			btfss	STATUS,Z			; 
			goto	$+3					; 
			movf	data_e,w			;  
		return							; 
			btfss	STATUS,C			; 
			goto	$+3					; 
			movf	data_e,w			; 
			goto	$+2					; 
			movf	perem1,w			; 
			bsf		E_data				;   EEPROM
		return							; 
;=================================================================================================
rd_eeprom	movfw	adr_e			;    
			BANKSEL	EEADR			;   EEADR
			movwf	EEADR			;   
			BANKSEL	EECON1			; 
			BCF 	EECON1,EEPGD	;    (EEPROM)
			bsf		EECON1,RD		;     EEPROM
			BANKSEL	EEDATA			; 
			movfw	EEDATA			;    
			BANKSEL	data_e			;   data_e
			movwf	data_e			;   
	return
;=================================================================================================
zap_eeprom								;   EEPROM
			movf	INTCON,w
			movwf	perem5				;    INTCON			
			bcf		INTCON,GIE			;   			

			movlw	(end_stek-flag_0)+1	;	;       Tzad_h1  kol_oh_vv	
			movwf	chtteep				; 
			movlw	flag_0
			movwf	FSR					;    
			clrf	adr_e				; 			

povch1		
			movf	INDF,w				;      
			call	zap_2byt_eeprom		;
			incf	FSR,f
			incf	adr_e,f				;   EEPROM
			decfsz	chtteep,f				;      
			goto	povch1				;    
			movf	perem5,w
			movwf	INTCON				;    INTCON
	return								;
;********************************************************************************************
zap_2byt_eeprom							;
			movwf	data_e				;
			movwf	perem2				;
			call	wr_eeprom			;
			incf	adr_e,f				;    EEPROM 
			movf	perem2,w			;
			movwf	data_e				;
			call	wr_eeprom			;
	return								;
;********************************************************************************************				
;********************************************************************************************				
;				   EEPROM
wr_eeprom		
			BANKSEL	EECON1
			btfsc	EECON1,WR		;      EEPROM
		goto	$-1					; 
			BCF 	EECON1,EEPGD	; Point to DATA	memory
			bsf		EECON1,WREN		;  
			BANKSEL	adr_e			; 
			movfw	adr_e			; 
			BANKSEL	EEADR			; 			
			movwf	EEADR			;   1
			BANKSEL	data_e			; 
			movfw	data_e			;      
			BANKSEL	EEDATA			; 
			movwf	EEDATA			;  EEPROM
			BANKSEL	EECON2			; 
			movlw	0x55			;     EEPROM
			movwf	EECON2			;
			movlw	0xAA			;
			movwf	EECON2			;
			bsf		EECON1,WR		;  
;			btfsc	EECON1,WR		;      EEPROM
;		goto	$-1	
			bcf		STATUS,RP0		;   0
			bcf		STATUS,RP1		;   0
	return
;********************************************************************************************
;********************************************************************************************
;				   EEPROM
stop_wr_e		
			BANKSEL	EECON1
			btfsc	EECON1,WR		;      EEPROM
			goto	$-1
			bcf		EECON1,WREN		;  			
			bcf		STATUS,RP0		;   0
			bcf		STATUS,RP1		;   0
	return								;
;********************************************************************************************
;============================================================================================
;============================================================================================
;***  24/16      7    ****************
;    24   - - 8 388 607  + 8 388 607
;  16   - - 32767  + 32767
										;   binl, binh, binu
										;  edin,dest,sotn,tysc,dtys,stys,mlon
										; B24 0  16 , 1- 24 (16  )
										; BTE    00  0
										; BTE0_00	 " "    - 0,00
bin_dec
;===============================================
				movfw	binu			; 
				movwf	t_binu			; 
				movfw	binh			; 
				movwf	t_binh			; 
				movfw	binl			; 
				movwf	t_binl			; 
;===============================================							
				bcf		MINUS			;    
				btfsc	B24				;   
			goto	bi0p				; 
				clrf	binu			;      16  
				btfss	binh,7			;   			
				goto	bi0				; 
			goto	comfd				;
bi0p			btfss	binu,7			;   
			goto	bi0					; 
				comf	binu,f			;       	
comfd			bsf		MINUS			;     
				comf	binl,f			; 
				comf	binh,f			; 
				movlw	.1				; 
				addwf	binl,f			; 
			BNC		bi0					; 
				addwf	binh,f			; 
			BNC		bi0					; 
				incf	binu,f			; 
;===============================================
bi0				bcf		B24				;    24  
	 			bcf     STATUS,0        ; clear the carry bit
				movlw   .24				; 
				movwf   count			; 
				clrf    R3				; 
				clrf    R2				; 
				clrf    R1				; 
				clrf    R0				; 
loop24  		rlf     binl, F			; 
				rlf     binh, F			; 
				rlf     binu, F			; 
				rlf     R0, F			; 
				rlf     R1, F			; 
				rlf     R2, F			; 
				rlf     R3, F			; 
				decfsz  count, F		; 
			goto    adjDEC				; 
;===============================================
				movfw	R3				; 
				andlw	b'00001111'		; 
				movwf	mlon			; 
				swapf	R2,w			; 
				andlw	b'00001111'		; 
				movwf	stys			; 
				movfw	R2				; 
				andlw	b'00001111'		; 
				movwf	dtys			; 
				swapf	R1,w			; 
				andlw	b'00001111'		; 
				movwf	tysc			; 
				movfw	R1				; 
				andlw	b'00001111'		; 
				movwf	sotn			; 
				swapf	R0,w			; 
				andlw	b'00001111'		; 
				movwf	dest			; 
				movfw	R0				; 
				andlw	b'00001111'		; 
				movwf	edin			; 
;===============================================
		;    		
gnn				movlw	.10				;    ()
				movf	mlon,f			;   
				BNZ		preo01			;     
				movwf	mlon			;    
				
				movf	stys,f			;   
				BNZ		preo01			;     
				movwf	stys			;    
				
				movf	dtys,f			;   
				BNZ		preo01			;     
				movwf	dtys			;    
				
				movf	tysc,f			;   
				BNZ		preo01			;     
				movwf	tysc			;    	
				
				movf	sotn,f			;   
				BNZ		preo01			
				btfss	BTE0_00			;    0  00
			goto	tuns				;   0
				bcf		BTE0_00			;    
			goto	preo01				;   00				
tuns			movwf	sotn			;    	
				movf	dest,f			;   
				BNZ		preo01			; 
				btfss	BTE				;    0  00
			goto	tunn				;   0
				bcf		BTE				;    
			goto	preo01				;   00				
tunn			movwf	dest			;    				
;===============================================
preo01		;       
				btfss	MINUS			;
			goto 	concis				;
				movlw	.10				;      
				subwf	dest,w			; 
				btfss	STATUS,Z		;
				goto 	mt60			; 
				movlw	.11				;
				movwf	dest			;    
			goto 	concis				;
mt60			movlw	.10				;      
				subwf	sotn,w			; 
				btfss	STATUS,Z		;
				goto 	mt61			; 
				movlw	.11				;
				movwf	sotn			;    
			goto 	concis				;
mt61			movlw	.10				;      
				subwf	tysc,w			; 
				btfss	STATUS,Z		;
				goto 	mt62			; 
				movlw	.11				;
				movwf	tysc			;    
			goto 	concis				;
mt62			movlw	.10				;      
				subwf	dtys,w			; 
				btfss	STATUS,Z		;
				goto 	mt63			; 
				movlw	.11				;
				movwf	dtys			;    
			goto 	concis				;
mt63			movlw	.10				;      
				subwf	stys,w			; 
				btfss	STATUS,Z		;
				goto 	mt64			; 
				movlw	.11				;
				movwf	stys			;    
			goto 	concis				;
mt64			movlw	.11				;
				movwf	mlon			;    					
;===============================================
			;      
concis			movf	mlon,w			; 
				call 	deshif			; 
				movwf	mlon			;
				movf	stys,w			; 
				call 	deshif			; 
				movwf	stys			;			
				movf	dtys,w			; 
				call 	deshif			; 
				movwf	dtys			;
				movf	tysc,w			; 
				call 	deshif			; 
				movwf	tysc			;
				movf	sotn,w			; 
				call 	deshif			; 
				movwf	sotn			;
				movf	dest,w			; 
				call 	deshif			; 
				movwf	dest			;
				movf	edin,w			; 
				call 	deshif			; 
				movwf	edin			;
;===============================================
				movfw	t_binu			; 
				movwf	binu			; 
				movfw	t_binh			; 
				movwf	binh			; 
				movfw	t_binl			; 
				movwf	binl			; 
;===============================================
		RETLW   0			;   
;===============================================
adjDEC 		 	movlw   R0				;
				movwf   FSR				;
				call    adjBCD			;
		 		movlw   R1				;
				movwf   FSR				;
				call    adjBCD			;
				movlw   R2				;
				movwf   FSR				;
				call    adjBCD			;
				movlw   R3				;
				movwf   FSR				;
				call    adjBCD			;
			goto    loop24				;
;===============================================
adjBCD 			movlw   3				;
				addwf   0,W				;
				movwf   temp			;
				btfsc   temp,3          ; test if result > 7
				movwf   0				;
				movlw   30				;
				addwf   0,W				;
				movwf   temp			;
				btfsc   temp,7          ; test if result > 7
				movwf   0    	        ; save as MSD
		RETLW   0						;
;===============================================
;============================================================================================					
;============================================================================================


;============================================================================================
sravnenie								; 16 & 16  
;  peAsh,peAsl  peBsh,peBsl
;    RAV,BOL,MEN,BOL_RAV,MEN_RAV

			clrf	flag_srv			;   
			clrf	regsr				;    

sr16z		btfsc	peAsh,7				;  7   0 
			bsf		regsr,0				;  1 .  1  0 .
			btfsc	peBsh,7				;  7   0 
			bsf		regsr,1				;  1 .  1  1 .
										; 0   
										; 1  .
										; 2  
										; 3  .
						;   
						;   
uzs			movf	regsr,f				;
			BZ		srv					;        
			movlw	.1					; 
			subwf	regsr,w				;   5 = 1,  peAsh , ,  peBsh 
			BNZ		$+4					;
			bsf		MEN					;  peBsh>peAsh 
			bsf		MEN_RAV				;
		return							; 
			movlw	.2					;   5 = 2   peBsh , ,  peAsh 
			subwf	regsr,w				;
			BNZ		srv					;         
			bsf		BOL					;  peBsh<peAsh  
			bsf		BOL_RAV				;
		return							; 
	;===================================   
srv										;
			movf	peAsh,w				;   
			subwf	peBsh,w				;(  )
			btfss	STATUS,Z
			goto	$+2					;   
			goto	prs					;     
			movf	peAsh,w				; 
			subwf	peBsh,w				;   
			btfsc	STATUS,C			;
			goto	$+4					;
			bsf		BOL					; peAsh>peBsh    
			bsf		BOL_RAV				;
		return							; 
			bsf		MEN					; peAsh<peBsh     			
			bsf		MEN_RAV				;
		return							;
prs			movf	peAsl,w				;   
			subwf	peBsl,w				;(  )
			btfss	STATUS,Z
			goto	$+.5				;   
			bsf		RAV					; peAsh=peBsh  perem2=peBsh
			bsf		MEN_RAV				; 
			bsf		BOL_RAV				; 		
		return
			movf	peAsl,w				; 
			subwf	peBsl,w				;   
			btfsc	STATUS,C
			goto	$+4					;
			bsf		BOL					; peAsh=peBsh  perem2>
			bsf		BOL_RAV
		return							; 
			bsf		MEN					; peAsh=peBsh  perem2< 
			bsf		MEN_RAV				;
		return							;
;============================================================================================

;============================================================================================
kondosdata			;   
;		;     
			movf	Up_alr_lo,w		;
			movwf	peAsl			;     	
			movf	Up_alr_hi,w		;
			movwf	peAsh			;			
			movlw	0xE7			;600
			movwf	peBsl			;  
			movlw	0x03			; 
			movwf	peBsh			;  
			call    sravnenie		;
			btfsc	BOL				;   
		goto	vos_data			;
			clrf	peBsl			;  
			clrf	peBsh			;  
			call    sravnenie		;
			btfsc	MEN				;   
		goto	vos_data			;
;		;    
			movf	Dn_alr_lo,w		;
			movwf	peAsl			;     	
			movf	Dn_alr_hi,w		;
			movwf	peAsh			;			
			movlw	0xE7			;600
			movwf	peBsl			;  
			movlw	0x03			;
			movwf	peBsh			;  
			call    sravnenie		;
			btfsc	BOL				;   
		goto	vos_data			;
			clrf	peBsl			;  
			clrf	peBsh			;  
			call    sravnenie		;
			btfsc	MEN				;   
		goto	vos_data			;
;		;            
			movf	Vr_zak_lo,w		;
			movwf	peAsl			;     	
			clrf	peAsh			;			
			movlw	0xF0			;+ 240
			movwf	peBsl			;  
			clrf	peBsh			;  
			call    sravnenie		;
			btfsc	BOL				;   
		goto	vos_data			;
			clrf	peBsl			;  
			clrf	peBsh			;  
			call    sravnenie		;
			btfsc	MEN				;   
		goto	vos_data			;
;		;    
			movf	Vr_pov_lo,w		;
			movwf	peAsl			;     	
			clrf	peAsh			;			
			movlw	0xF0			;+ 240
			movwf	peBsl			;  
			clrf	peBsh			;  
			call    sravnenie		;
			btfsc	BOL				;   
		goto	vos_data			;
			clrf	peBsl			;  
			clrf	peBsh			;  
			call    sravnenie		;
			btfsc	MEN				;   
		goto	vos_data			;
;		;    
			movf	kalibr_lo,w		;
			movwf	peAsl			;     	
			movf	kalibr_hi,w		;
			movwf	peAsh			;			
			clrf	peBsl			;  
			clrf	peBsh			;  
			call    sravnenie		;
			btfsc	MEN				;   
		goto	vos_data			;
	return	
;====================================
vos_data	
			;         EEPROM
			BANKSEL	TRISB				;  TRISB
			clrf	TRISB				;        
			BANKSEL	PORTB				; 
			
			clrf	flag_0				; 

			clrf	Up_alr_hi			;* 
			movlw	0xf0				;
			movwf	Up_alr_lo			;*
			
			clrf	Dn_alr_hi			;* 
			movlw	0x0a				;
			movwf	Dn_alr_lo			;*
			

			movlw	0x0a				;
			movwf	Vr_zak_lo			;*

			movlw	0x0a				;
			movwf	Vr_pov_lo			;*

			movlw	0x80				;
			movwf	kalibr_lo			;*

			movlw	0x25				;
			movwf	kalibr_hi			;*
			
			call	zap_eeprom			;      
alr_d
			
			bcf		RELE1				;   
			clrf	flag_i1				; 
			clrf	flag_i2				; 			
			movlw	.40					; 
			call	big_str				;   
		goto	alr_d					; 
;============================================================================================

;********************************************************************************************************
conv_volt								;   
				;     00 + 999 ed
			call	bin_dec					;
			movf	binh,w			;  >999
			movwf	peAsh			;			
			movf	binl,w			;
			movwf	peAsl			;
			movlw	0x03			;
			movwf	peBsh			;
			movlw	0xE7			;
			movwf	peBsl			;
			call    sravnenie		;
			btfss	BOL				;
		goto	p_ind_r1			;
			movlw	.50  			; 
			call	big_str			;   - 
			call 	och_left		;  
	return	
					
;				 
p_ind_r1
			btfsc	R_ind
		goto	obind
			btfss	RELE1			;    
			goto	$+3				;
			bsf		TOCHm2			;
			goto	$+2				;
			bcf		TOCHm2			;
			bcf		TOCHm3			;			
			bcf		TOCHKA3			;
			bsf		TOCHKA2			;
			movfw	edin			; 
			movwf	ind_3			; 
			movfw	dest			; 
			movwf	ind_2			; 
			movfw	sotn			; 
			movwf	ind_1			; 				
		return						; 
obind
			btfss	RELE1			;    
			goto	$+3				;
			bsf		TOCHm3			;
			goto	$+2				;
			bcf		TOCHm3			;
			bcf		TOCHm2			;
			bsf		TOCHKA3
			bcf		TOCHKA2
			movfw	edin			; 
			movwf	ind_3			; 
			movfw	dest			; 
			movwf	ind_2			; 
			movfw	sotn			; 
			movwf	ind_1			; 				
		return						;

;********************************************************************************************************
;*************************************************************************************************
Voltmetr												;  		
;				btfss	IZM						;    
;		return									;
;				bcf		IZM
				movf	ChTiz,f					;
				SKPNZ							;
				goto	$+5						;
				movlw	.2						;
				subwf	ChTiz,f					;
				SKPZ							;
				goto	$+3						;
				movlw	.8						;
				movwf	ChTiz					;
				bsf		IZM_ACP					;  
				btfsc	IZM_ACP					;    
				goto	$-1						;

				movlw	ChTiz					;
				addwf	ChTiz,w					;
				movwf	FSR						;
				bsf		STATUS,RP0				; RP0-1   1  				
				movfw	ADRESL					;    
				bcf		STATUS,RP0				;   0				
				movwf	INDF					;     
				movfw	ADRESH					;    	
				decf	FSR,f					;
				movwf	INDF					;     
;+++++++++++++++++++++++     4  
				movlw	Til4					; 
				movwf	FSR						; 
				movfw	INDF					; 
				movwf	SIN_lo					; 
				decf	FSR,f					; 
				movfw	INDF					; 
				movwf	SIN_hi					; 

				movlw	.3						; 
				movwf	Chokr					; 
				
zag1			decf	FSR,f					; 
				movfw	INDF					; 
				addwf	SIN_lo,f
				SKPNC							; 
				incf	SIN_hi,f				; 
				decf	FSR,f					; 
				movfw	INDF					; 
				addwf	SIN_hi,f				; 
				decfsz	Chokr,f					; 				
				goto	zag1					; 
				
				CLRC							; 
				rrf		SIN_hi,f				; 
				rrf		SIN_lo,f				; 
				CLRC							; 
				rrf		SIN_hi,f				; 
				rrf		SIN_lo,f				; 
				
				;     10 000
				clrf	peAsu					; 
				movfw	SIN_hi					; 			
				movwf	peAsh					; 
				movfw	SIN_lo					; 			
				movwf	peAsl					; 			
				
				clrf	peBsu					; 
				movlw	0x27					; 			
				movwf	peBsh					; 
				movlw	0x10					; 			
				movwf	peBsl					; 			
				call	D_mpyS					; 
	
				movfw	peBsl					;      			
				movwf	peAsu					; 
				movfw	peCsh					; 			
				movwf	peAsh					; 
				movfw	peCsl					; 			
				movwf	peAsl					; 

				clrf	peBsu					;   10250 (280)
				movf	kalibr_hi,w				;
				movwf	peBsh					;
				movf	kalibr_lo,w				;
				movwf	peBsl					;
 
				call	FXD2424U				; 
				
				movfw	peAsh					; 			
				movwf	U_izm_hi				; 				
				movfw	peAsl					; 			
				movwf	U_izm_lo				; 
		return	
;********************************************************************************************************
;*************************************************************************************************
;                     ( 16x16 -> 32 )
;        ,;  -  ,  -  
D_mpyS			movf    peAsh,W      	;
				xorwf   peBsh,W     	;
				movwf  	sign     		;
				btfss   peBsh,7       	; if MSB set go & negate ACCb
		goto    $+6     				;
   				comf    peBsl,F      	;  
				incf    peBsl,F     	;
				btfsc   STATUS,Z     	;
				decf    peBsh,F     	;
				comf    peBsh,F     	;
		 		btfss   peAsh,7    		; if MSB set go & negate ACCa
		goto	$+6     				;
		  		comf    peAsl,F   		;  
				incf    peAsl,F	     	;
				btfsc   STATUS,Z     	;
				decf    peAsh,F     	;
				comf    peAsh,F     	;
  				
				movlw   .16        		; for 16 shifts
				movwf  	temp     		;
				movf    peBsh,W      	;move b to d
				movwf  	peDsh     		;
				movf    peBsl,W     	;
				movwf  	peDsl    	 	;
				clrf    peBsh    	 	;
				clrf    peBsl    	 	;
				
				call	mulMac   	  	;
				decfsz	temp,f   	  	;
				goto	$-2     		;
				
				btfss   sign,7   	  	;
		retlw   0     					;
				comf    peCsl,F    		;  CB ( -CB -> CB )
				comf    peCsh,F     	;
				comf    peBsl,F     	;
				comf    peBsh,F     	;
				incf    peCsl,F     	;
				btfsc   STATUS,Z     	;
				incf	peCsh,F     	;
				btfsc   STATUS,Z     	;
				incf	peBsl,F     	;
				btfsc  	STATUS,Z     	;
				incf   	peBsh,F     	;
	retlw   0    					 	;
;**********************************
mulMac			rrf     peDsh,F   		;  d 
				rrf     peDsl,F     	;
				btfss   STATUS,C   		;need to add?
			goto    NO_ADD         		; no addition necessary
				movf    peAsl,W     	; Addition ( ACCb + ACCa -> ACCb )
				addwf   peBsl,F      	;add lsb
				btfsc   STATUS,C    	;add in carry
				incf    peBsh,F     	;
				movf    peAsh,W     	;
				addwf   peBsh,F     	;add msb
NO_ADD  		rrf     peBsh,F     	;
				rrf     peBsl,F     	;
				rrf     peCsh,F     	;
				rrf     peCsl,F     	;
	return   						  	;
;*************************************************************************************************
;**********************************************************************************************
       
;       24/24 Bit Unsigned Fixed Point Divide 24/24 -> 24.24

;            24/24  

;       Input:  24 bit       -  peAsu, peAsh,peAsl
;               24 bit       - peBsu, peBsh, peBsl
;       Use:    CALL    FXD2424U
;       Output: 24 bit       - peAsu, peAsh,peAsl
;               24 bit       - peCsu, peCsh, peCsl

;       Result: AARG, REM  <--  AARG / BARG
;       Max Timing:     3+671+2 = 676 clks
;       Max Timing:     3+639+2 = 644 clks
;       PM: 3+222+1 = 226               DM: 13

FXD2424U   		CLRF            peCsu
           		CLRF            peCsh
           		CLRF            peCsl

                CLRF            temp

                RLF             peAsu,W
                RLF             peCsl, F
                MOVF            peBsl,W
                SUBWF           peCsl, F
                MOVF            peBsh,W
                BTFSS           STATUS,C
                INCFSZ          peBsh,W
                SUBWF           peCsh, F
                MOVF            peBsu,W
                BTFSS           STATUS,C
                INCFSZ          peBsu,W
                SUBWF           peCsu, F

                MOVLW  .0
                BTFSS           STATUS,C
                MOVLW           1
                SUBWF           temp, F
                RLF             peAsu, F

                MOVLW           7
                MOVWF           regsr

LOOPU2424A      RLF             peAsu,W
                RLF             peCsl, F
                RLF             peCsh, F
                RLF             peCsu, F
                RLF             temp, F
                MOVF            peBsl,W
                BTFSS           peAsu,0
                GOTO            UADD44LA

                SUBWF           peCsl, F
                MOVF            peBsh,W
                BTFSS           STATUS,C
                INCFSZ          peBsh,W
                SUBWF           peCsh, F
                MOVF            peBsu,W
                BTFSS           STATUS,C
                INCFSZ          peBsu,W
                SUBWF           peCsu, F
                MOVLW  .0
                BTFSS           STATUS,C
                MOVLW           1
                SUBWF           temp, F
                GOTO            UOK44LA

UADD44LA        ADDWF           peCsl, F
                MOVF            peBsh,W
                BTFSC           STATUS,C
                INCFSZ          peBsh,W
                ADDWF           peCsh, F
                MOVF            peBsu,W
                BTFSC           STATUS,C
                INCFSZ          peBsu,W
                ADDWF           peCsu, F
                MOVLW  .0
                BTFSC           STATUS,C
                MOVLW           1
                ADDWF           temp, F
        
UOK44LA 		RLF             peAsu, F

                DECFSZ          regsr, F
                GOTO            LOOPU2424A

                RLF             peAsh,W
                RLF             peCsl, F
                RLF             peCsh, F
                RLF             peCsu, F
                RLF             temp, F
                MOVF            peBsl,W
                BTFSS           peAsu,0
                GOTO            UADD44L8

                SUBWF           peCsl, F
                MOVF            peBsh,W
                BTFSS           STATUS,C
                INCFSZ          peBsh,W
                SUBWF           peCsh, F
                MOVF            peBsu,W
                BTFSS           STATUS,C
                INCFSZ          peBsu,W
                SUBWF           peCsu, F
                MOVLW  .0
                BTFSS           STATUS,C
                MOVLW           1
                SUBWF           temp, F
                GOTO            UOK44L8

UADD44L8        ADDWF           peCsl, F
                MOVF            peBsh,W
                BTFSC           STATUS,C
                INCFSZ          peBsh,W
                ADDWF           peCsh, F
                MOVF            peBsu,W
                BTFSC           STATUS,C
                INCFSZ          peBsu,W
                ADDWF           peCsu, F
                MOVLW  .0
                BTFSC           STATUS,C
                MOVLW           1
                ADDWF           temp, F
        
UOK44L8         RLF             peAsh, F

                MOVLW           7
                MOVWF           regsr

LOOPU2424B      RLF             peAsh,W
                RLF             peCsl, F
                RLF             peCsh, F
                RLF             peCsu, F
                RLF             temp, F
                MOVF            peBsl,W
                BTFSS           peAsh,0
                GOTO            UADD44LB

                SUBWF           peCsl, F
                MOVF            peBsh,W
                BTFSS           STATUS,C
                INCFSZ          peBsh,W
                SUBWF           peCsh, F
                MOVF            peBsu,W
                BTFSS           STATUS,C
                INCFSZ          peBsu,W
                SUBWF           peCsu, F
                MOVLW  .0
                BTFSS           STATUS,C
                MOVLW           1
                SUBWF           temp, F
                GOTO            UOK44LB

UADD44LB        ADDWF           peCsl, F
                MOVF            peBsh,W
                BTFSC           STATUS,C
                INCFSZ          peBsh,W
                ADDWF           peCsh, F
                MOVF            peBsu,W
                BTFSC           STATUS,C
                INCFSZ          peBsu,W
                ADDWF           peCsu, F
                MOVLW  .0
                BTFSC           STATUS,C
                MOVLW           1
                ADDWF           temp, F
        
UOK44LB         RLF             peAsh, F

                DECFSZ          regsr, F
                GOTO            LOOPU2424B

                RLF             peAsl,W
                RLF             peCsl, F
                RLF             peCsh, F
                RLF             peCsu, F
                RLF             temp, F
                MOVF            peBsl,W
                BTFSS           peAsh,0
                GOTO            UADD44L16

                SUBWF           peCsl, F
                MOVF            peBsh,W
                BTFSS           STATUS,C
                INCFSZ          peBsh,W
                SUBWF           peCsh, F
                MOVF            peBsu,W
                BTFSS           STATUS,C
                INCFSZ          peBsu,W
                SUBWF           peCsu, F
                MOVLW  .0
                BTFSS           STATUS,C
                MOVLW           1
                SUBWF           temp, F
                GOTO            UOK44L16

UADD44L16       ADDWF           peCsl, F
                MOVF            peBsh,W
                BTFSC           STATUS,C
                INCFSZ          peBsh,W
                ADDWF           peCsh, F
                MOVF            peBsu,W
                BTFSC           STATUS,C
                INCFSZ          peBsu,W
                ADDWF           peCsu, F
                MOVLW  .0
                BTFSC           STATUS,C
                MOVLW           1
                ADDWF           temp, F
        
UOK44L16        RLF             peAsl, F

                MOVLW           7
                MOVWF           regsr

LOOPU2424C      RLF             peAsl,W
                RLF             peCsl, F
                RLF             peCsh, F
                RLF             peCsu, F
                RLF             temp, F
                MOVF            peBsl,W
                BTFSS           peAsl,0
                GOTO            UADD44LC

                SUBWF           peCsl, F
                MOVF            peBsh,W
                BTFSS           STATUS,C
                INCFSZ          peBsh,W
                SUBWF           peCsh, F
                MOVF            peBsu,W
                BTFSS           STATUS,C
                INCFSZ          peBsu,W
                SUBWF           peCsu, F
                MOVLW  .0
                BTFSS           STATUS,C
                MOVLW           1
                SUBWF           temp, F
                GOTO            UOK44LC

UADD44LC        ADDWF           peCsl, F
                MOVF            peBsh,W
                BTFSC           STATUS,C
                INCFSZ          peBsh,W
                ADDWF           peCsh, F
                MOVF            peBsu,W
                BTFSC           STATUS,C
                INCFSZ          peBsu,W
                ADDWF           peCsu, F
                MOVLW  .0
                BTFSC           STATUS,C
                MOVLW           1
                ADDWF           temp, F
        
UOK44LC 		RLF             peAsl, F

                DECFSZ          regsr, F
                GOTO            LOOPU2424C

                BTFSC           peAsl,0
                GOTO            UOK44L
                MOVF            peBsl,W
	        	ADDWF           peCsl, F
                MOVF            peBsh,W
                BTFSC           STATUS,C
                INCFSZ          peBsh,W
                ADDWF           peCsh, F
                MOVF            peBsu,W
                BTFSC           STATUS,C
                INCFSZ          peBsu,W
                ADDWF           peCsu, F
UOK44L
         RETLW           0x00

;**********************************************************************************************
;============================================================================================
;********************************************************************************************
				FILL(goto 0x00),0x800-$   ;     



;============================================================================================











; initialize eeprom locations
;============================================================================================										
;++++++++++++++++++++++++++    EEPROM +++++++++++++++++++++++++++++++++++++++
			ORG		0x2100						; 							

			DE		.00,.00 					;flag_0									;*    
			DE		0x00,0x00,0xf0,0xf0			;Up_alr_hi,Up_alr_lo	50.0v			;*   
			DE		0x00,0x00,0x0a,0x0a			;Dn_alr_hi,Dn_alr_lo	1.0v			;*   
			DE		0x0a,0x0a					;Vr_zak_lo				60 sek			;*           
			DE		0x0a,0x0a					;Vr_pov_lo				0 sek			;*   
			DE		0x25,0x25,0x80,0x80			;kalibr_hi,kalibr_lo					;*  
			DE		.0,.0						;end_stek								;*
;============================================================================================

	END                       ; directive 'end of program'

;=======================================================================================================
